{%- macro vote(entity, route) -%}
  {{- block('vote') -}}
{%- endmacro -%}

{%- block vote -%}
  {%- set user_vote = is_granted('ROLE_USER') ? entity.userVote(app.user) : null -%}
  {%- spaceless -%}
    <form action="{{ path(route, {id: entity.id}) }}"
          method="post"
          class="vote {{ block('vote_class') }}"
          data-ajax-action="{{ path(route, {id: entity.id, _format: 'json'}) }}"
          data-score="{{ entity.netScore }}">

      {# csrf_token starts a session #}
      {% if is_granted('ROLE_USER') %}
        <input type="hidden" name="token" value="{{ csrf_token('vote') }}">
      {% endif %}

      <button type="submit" name="choice" value="{{ block('vote_choice_up') }}"
              class="vote-button vote-up" title="{{ block('vote_up_label') }}">
        <span class="inner" aria-hidden="true"><span class="icon icon-up"></span></span>
      </button>

      <span class="vote-score">{{ entity.netScore }}</span>

      <button type="submit" name="choice" value="{{ block('vote_choice_down') }}"
              class="vote-button vote-down" title="{{ block('vote_down_label') }}">
        <span class="inner" aria-hidden="true"><span class="icon icon-down"></span></span>
      </button>
    </form>
  {%- endspaceless -%}
{%- endblock -%}

{%- block vote_class -%}
  {%- if not user_vote -%}
    {#- nothing -#}
  {%- elseif user_vote.upvote -%}
    vote-user-upvoted
  {%- else -%}
    vote-user-downvoted
  {%- endif -%}
{%- endblock -%}

{%- block vote_choice_up -%}
  {{- user_vote and user_vote.upvote ? 0 : 1 -}}
{%- endblock -%}

{%- block vote_choice_down -%}
  {{- user_vote and not user_vote.upvote ? 0 : -1 -}}
{%- endblock -%}

{%- block vote_up_label -%}
  {{- (user_vote and user_vote.upvote ? 'votes.retract_upvote' : 'votes.upvote')|trans -}}
{%- endblock -%}

{%- block vote_down_label -%}
  {{- (user_vote and not user_vote.upvote ? 'votes.retract_downvote' : 'votes.downvote')|trans -}}
{%- endblock -%}
